% function [Catalog] = CatalogFilterNaN(fullcatalog,...)
% Select lines/values from catalog without NaN and empty string
% Input parameters are pairs:
%   names of fields
%   eg. CatalogSelectRange(fullcatalog,'Mw','EID')
%
% (c) Dorota Olszewska IG PAS

function [Catalog] = CatalogFilterNaN(fullcatalog,varargin)
    Catalog = fullcatalog ;
    range = true(size(fullcatalog(1).val)) ;
    na_varargin = numel(varargin) ;
    for i= 1:na_varargin
        if ~ischar(varargin{i})
            warning(['Wrong type of parameter ' num2str(i)])
            continue
        end
        index = find(strcmp(varargin{i},{fullcatalog.field})) ;
        if length(index) ~= 1
            warning(['Can not select field ' varargin{i}])
            continue
        end
        if fullcatalog(index).type == 3
            for ii=1:length(Catalog(index).val)
            lrange(ii,1) = ~isempty(Catalog(index).val{ii});
            end
         else
            lrange = ~isnan(fullcatalog(index).val) ;
        %nnel = numel(lrange) ;
        end
        range = range & lrange;
    end
    for i = 1:numel(fullcatalog)
        if fullcatalog(i).type == 3
            Catalog(i).val =  {fullcatalog(i).val{range}}' ;
        else
            Catalog(i).val =  fullcatalog(i).val(range) ;
        end
    end
end
